% ========= FLOATS =========
\usepackage{subcaption}
% >>>>>>>>> TABLES =========
% \usepackage{multirow}
\usepackage[table,dvipsnames]{xcolor}
\usepackage{booktabs}
% >>>>>>>>> LIST OF EQUATIONS =========
\usepackage{tocloft}
\newcommand{\listequationname}{List of Equations}
\newlistof{equations}{equ}{\listequationname}
\newcommand{\equationlistentry}[1]{%
\addcontentsline{equ}{equations}{\protect\numberline{\theequation}#1}\par}
\setlength{\cftequationsindent}{1.5em}
\setlength{\cftequationsnumwidth}{2.3em}
\renewcommand{\cftequtitlefont}{\normalfont\Large\bfseries}
% >>>>>>>>> LIST OF DEFINITIONS =========
\newcommand{\listdefinitionname}{List of Definitions}
\newlistof{definitions}{idef}{\listdefinitionname}
\newcommand{\definitionlistentry}[1]{%
\addcontentsline{idef}{definitions}{\protect\numberline{\thedefinition}#1}\par}
\setlength{\cftdefinitionsindent}{1.5em}
\setlength{\cftdefinitionsnumwidth}{2.3em}
\renewcommand{\cftideftitlefont}{\normalfont\Large\bfseries}
% >>>>>>>>> ALGORITHMS =========
\usepackage{algorithm}
\usepackage{algpseudocode}
\algtext*{EndFunction}% Remove "end function" text
\algtext*{EndIf}% Remove "end if" text
\algtext*{EndFor}% Remove "end for" text
\MakeRobust{\Call} % nesting \Call command

\usepackage{color}
\definecolor{dkgreen}{rgb}{0,0.6,0}
\definecolor{gray}{rgb}{0.5,0.5,0.5}
\definecolor{mauve}{rgb}{0.58,0,0.82}
\definecolor{gray}{rgb}{0.4,0.4,0.4}
\definecolor{darkblue}{rgb}{0.0,0.0,0.6}
\definecolor{lightblue}{rgb}{0.0,0.0,0.9}
\definecolor{cyan}{rgb}{0.0,0.6,0.6}
\definecolor{darkred}{rgb}{0.6,0.0,0.0}

\usepackage{listings}

\lstset{
  basicstyle=\ttfamily\footnotesize,
  columns=fullflexible,
  showstringspaces=false,
  numbers=left,                   % where to put the line-numbers
  numberstyle=\tiny\color{gray},  % the style that is used for the line-numbers
  stepnumber=1,
  numbersep=5pt,                  % how far the line-numbers are from the code
  backgroundcolor=\color{white},      % choose the background color. You must add \usepackage{color}
  showspaces=false,               % show spaces adding particular underscores
  showstringspaces=false,         % underline spaces within strings
  showtabs=false,                 % show tabs within strings adding particular underscores
  frame=none,                   % adds a frame around the code
  rulecolor=\color{black},        % if not set, the frame-color may be changed on line-breaks within not-black text (e.g. commens (green here))
  tabsize=2,                      % sets default tabsize to 2 spaces
  captionpos=b,                   % sets the caption-position to bottom
  breaklines=true,                % sets automatic line breaking
  breakatwhitespace=false,        % sets if automatic breaks should only happen at whitespace
  title=\lstname,                   % show the filename of files included with \lstinputlisting;
                                  % also try caption instead of title  
  commentstyle=\color{gray}\upshape
}

\lstdefinelanguage{XML}
{
  morestring=[s][\color{mauve}]{"}{"},
  morestring=[s][\color{black}]{>}{<},
  morecomment=[s]{<?}{?>},
  morecomment=[s][\color{dkgreen}]{<!--}{-->},
  stringstyle=\color{black},
  identifierstyle=\color{lightblue},
  keywordstyle=\color{red},
  morekeywords={
    xmlns,
    xsi,
    row,
    tags
  }% list your attributes here
}
% >>>>>>>>> KEEP POSITION =========
\usepackage{float} % for the H option of floating environments, to force position
\floatstyle{plain}
\restylefloat{figure}
\restylefloat{table}
\floatstyle{ruled}
\restylefloat{algorithm}